//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// Circle is a concrete class extending PositionalShape (and thus Shape).
// It defines concrete methods for all the abstract methods that it
// inherits, and defines a circle-specific instance variable (radius)
// and methods (getRadius, setRadius).
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


import java.awt.Rectangle;
import edu.cmu.cs.pattis.cs151xx.Prompt;



public class Circle extends PositionalShape {

  public Circle (String name, int centerX, int centerY, double r)
    { 
      super(name,centerX,centerY);
      radius = r;
    }
    
    //Overide the abstract method declared in Shape
    public double getArea()
    {return Math.PI * radius * radius;}

  //Overide/call the method declared in PositionalShape
    public void promptForInformation()
    {
      super.promptForInformation();
      radius = Prompt.forDouble("  Enter radius");
    }

    //Overide the abstract method declared in PositionalShapee
    public Rectangle getBoundingBox()
    {
      return new Rectangle( (int)(getCenter().x-radius),
                            (int)(getCenter().y-radius),
                            (int)(2*radius),
                            (int)(2*radius) );
    }
    
    public double getRadius()
    {return radius;}
    
    public void setRadius(double newRadius)
    {radius = newRadius;}

    public String toString( )
    {return "Circle[radius="+radius+","+super.toString()+"]";}

    //Fields
    private double radius;
  }