//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// Circle is a concrete class extending PositionalShape (and thus Shape).
// It defines concrete methods for all the abstract methods that it
// inherits, and defines a circle-specific instance variable (radius)
// and methods (getRadius, setRadius).
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


import edu.cmu.cs.pattis.cs151xx.Prompt;


public class Rectangle extends PositionalShape {

  public Rectangle (String name, int centerX,  int centerY,
                                 double width, double height)
  { 
    super(name,centerX,centerY);
    this.width = width;
    this.height= height;
  }
    
  //Overide the abstract method declared in Shape
  public double getArea()
  {return height*width;}

  //Overide/call the method declared in PositionalShape
  public void promptForInformation()
  {
    super.promptForInformation();
    width  = Prompt.forDouble("  Enter width");
    height = Prompt.forDouble("  Enter height");
  }

  //Overide the abstract method declared in PositionalShapee
  public java.awt.Rectangle getBoundingBox()
  {
    return new java.awt.Rectangle( (int)(getCenter().x-width/2),
                                   (int)(getCenter().y-height/2),
                                   (int)width,
                                   (int)height);
  }
    
  public double getWidth()
  {return width;}
    
  public double getHeight()
  {return height;}
    
  public void setWidthHeight(double newWidth, double newHeight)
  {
    width  = newWidth;
    height = newHeight;
  }

  public String toString( )
  {return "Rectangle[width="+width+",height="+height+","+super.toString()+"]";}

  //Fields
  private double width, height;
}